
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>深度学习挑战冯·诺依曼结构 / iVAN</title>

    <meta name="description" content="深度学习挑战冯·诺依曼结构 2016年10月27日 &quot;Nature&quot; 期刊第538卷,发表了Google 旗下的 DeepMind 团队写的人工智能的论文,题目是 &quot;Hybrid computing using a neural network with dynamic external memory&quot; [1],用配置了动态外部存储的神经网络,实现杂交计算.这篇论文介绍了 Differentiable Neural Computer 的实现细节.   DeepMind 团队在伦敦工作 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">深度学习挑战冯·诺依曼结构</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>2016年10月27日 “Nature” 期刊第538卷，发表了Google 旗下的 DeepMind 团队写的人工智能的论文，题目是 “Hybrid computing using a neural network with dynamic external memory” [1]，用配置了动态外部存储的神经网络，实现杂交计算。这篇论文介绍了 Differentiable Neural Computer 的实现细节。</p>
<p> </p>
<p>DeepMind 团队在伦敦工作，2014年被 Google 收购。DeepMind 开发的 AlphaGo，2016年年初战胜了围棋高手李世乭。</p>
<p> </p>
<p>早在 2014年12月，DeepMind 团队发表了一篇论文，“Neural Turing Machines” [2]。后来，他们对 Neural Turing Machines （NTM）的存储管理方式做了改进，命名为 Differentiable Neural Computer（DNC）。<strong>Differentiable 是可训练的意思，尤其是可以用 gradient descent 的算法来训练。</strong></p>
<p>冯·诺依曼体系<br />
<br />当今世界，所有计算机的体系，都源自于冯·诺依曼于 1945 年设计的体系，<strong>冯·诺依曼体系有三大要素：</strong></p>
<ol>
<li>基本操作，例如加减乘除。</li>
<li>逻辑流程控制，例如if-else-then，for，while。</li>
<li>外设存储器，内存和硬盘的寻址。 </li>
</ol>
<p> </p>
<p>想挑战冯·诺依曼，就必须从这三个要素入手。DeepMind 团队认为，冯·诺依曼体系中的逻辑流程控制和外设存储器使用，都必须在程序中写死，而不能通过观察范例，自动生成程序。</p>
<p> </p>
<p>如果把程序理解为把输入 x 转换为输出 y 的函数 f()，y = f(x)，那么 neural network 就是模拟任何函数的通用模型f^()。</p>
<p> </p>
<p><strong>但是早期的 neural network 有两个软肋：</strong></p>
<ol>
<li>不能实现 variable binding，也就是说，f() 的内部参数，不能随着输入 x 的不同而改变。</li>
<li>不能实现 variable-length structure，也就是说，输入 x 和输出 y 的维度都是定长的，不能改变。</li>
</ol>
<p> </p>
<p>早期 neural network 的这两个软肋，都不难修补。譬如循环神经网络 Recurrent Neural Network（RNN），就解决了这两个问题。换而言之，RNN 是 Turing-complete 的，可以用来模拟任何函数，当然也可以模拟任何程序的功能。</p>
<p> </p>
<p>既然冯·诺依曼体系的三大要素中的两个，基本操作和逻辑流程控制，都能够被 RNN 模拟，假如 RNN 也能够解决存储管理的问题，那么整个冯·诺依曼体系，就都能够被 RNN 来实现了。所以 <strong>Differentiable Neural Computer （DNC）的工作重点，在于存储管理。</strong></p>
<p> </p>
<p>[3] 深入浅出地解释了用RNN 来管理存储的原理。建议先读 [3]，再读 [2]，最后读 [1]。需要特别注意的，个人体会有几个方面，1. 存储的设置，2. 寻址机制，3. 需要训练哪些参数，4. 如何把 DNC 应用到 Graph 操作中。</p>
<p>存储的设置</p>
<p>[3] 把 NTM/DNC 的存储设置解释为 the memory is an array of vectors，也就是一个矩阵，每一行就是一个 vector，每行的 vector 的长度一致，所有行集结起来就是 array。在文中的例子中，[3] 把 memory 简化为 an array of scalar, 也就是 N 行单列的矩阵，每一行只存储一个数值。</p>
<p> </p>
<p>什么时候需要存储向量呢？如果存储里存放的是图像，那么每个存储单元上存储的是一个像素（r,g,b），像素就是一个向量，三个 bytes 组成的向量。</p>
<p> </p>
<p>但是如果需要存储的是一篇文章，每个存储单元上需要存储一个词，而每个词的长度不同，怎么办？三篇文章都没有说，但是简单的办法有二。</p>
<ol>
<li>每个存储单元上，预留足够长的 vector，遇到很短的词，空着的 byte 就全部填 0。</li>
<li>把每个词，无论长短，都转换为词向量，词向量的长度定长。第二个办法就是其它论文中说的 encoding 的办法。</li>
</ol>
<p> </p>
<p>另外要注意的是，存储矩阵的行数可能很多。想象一下，把一部长篇小说存放到存储矩阵里，每个词都占用一行，需要占用存储矩阵的多少行。</p>
<p> </p>
<p>寻址机制</p>
<p><strong>DNC 改进了NTM 的寻址机制。</strong>NTM 的寻址机制是 content-based 和 location-based 的混搭。为什么需要改进呢？原因有三。</p>
<ol>
<li>NTM 不能保障多个存储单元之间，不相互重叠，不相互干扰。dynamic memory allocation: allocate a free space</li>
<li>NTM 不能释放存储单元，如果处理很长的序列时，譬如处理一部超长的长篇小说，搞不好所有存储都会被占满，导致系统崩溃。dynamic memory allocation: free gates</li>
<li>如果连续做几个读写操作，它们所使用的存储单元的位置，最好是相邻的。但是在NTM 中，一旦某个读写操作，远远跳到其它存储区域，那么后续操作也跟着去其它区域，而且失忆，想不起来原先的存储区域在哪里。temporal link matrix</li>
</ol>
<p> </p>
<p><strong>DNC 的寻址机制，把读操作和写操作分开。</strong>DNC 用 content-based 和 dynamic memory allocation 的混搭方式，处理写操作。用 content-based 和 temporal memory linkage 的混搭方式，处理读操作。</p>
<p> </p>
<p><strong>1. content-based 寻址：</strong></p>
<p>比较需要处理的目标 vector，与存储矩阵中每一行的 vector，用余弦距离来计算两者相似性。取存储矩阵中，与目标 vector 距离最短的行。</p>
<p>计算余弦距离时，需要一个系数向量，beta，这个系数向量是被训练出来的。</p>
<p> </p>
<p><strong>2. dynamic memory allocation 存储单元分配：</strong></p>
<p>每一个存储单元，都是等长的 vector。当每一个存储单元被 free 的时候，整个 vector 中的每一个 element，都可以用来写入新数据。但是当一个 vector 中有若干 elements 已经被占用时，剩下的 elements 还可以被写入新数据。</p>
<p> </p>
<p>想象一下，如果每个 vector 的长度是 100，又如果某个 vector 里，已经写入了一个不长的词，但是还有剩余的 elements，这些剩余的 elements 可以用于给这个词做词性标注等等。但是如果剩余的 elements 不多，那么词性标注只好被写到其它行的 vector 里。</p>
<p> </p>
<p>DNC 设计了一个存储单元占用向量 u。u(i) = 0 时第i行的 vector 中，所有 element 都可以被写入新数据，而当 u(i) = 1 时第 i 行的 vector 中所有 elements 都已经被占用了。</p>
<p> </p>
<p>但是如果存储矩阵中有两行，i 和 j，分别有完全相同的 elements 可以被写。谁先被写，取决于权重向量 wt。wt 体现了存储使用的策略，策略既可以是尽可能写入最新释放的存储单元，也可以尽可能写入内容相似，而且没有被完全占用的存储单元。这个权重向量 wt，是可以根据被训练出来的。</p>
<p> </p>
<p><strong>3. Temporal memory linkage 读写时序的关联：</strong></p>
<p> </p>
<p>Dynamic memory allocation 没有记录历次写操作时，loc(t) 发生在哪个存储单元，以及loc(t+1) 发生在哪个存储单元。而记录历次写操作的存储单元的位置顺序，是有用的。</p>
<p> </p>
<p>DNC 用 N^2 的方阵，来记录 temporal link，其中 L(i, j) 记录着 t 时写操作发生在存储单元 j，而 t+1 时写操作发生在存储单元i的概率。L(i, j) 可以是简单的统计结果，也可以是加权的统计结果，权重体现了控制策略。权重是可以被训练出来的。</p>
<p> </p>
<p>当 N 很大的时，理论上来说 L 方阵会占用很多空间。但是鉴于 L 方阵很稀疏，很多 L(i, j) 等于 0。根据 DeepMind 团队的估算，L 实际占用空间只有 O( N )，计算成本只有 O( N * Log N )。</p>
<p>需要训练哪些参数?</p>
<p>除了读写操作、以及寻址操作中的几个权重向量以外，还有作为 controller 的 RNN 的参数。RNN 可以选择结构比较简单的 neuralnet work，也可以选择结构更复杂的 LSTM。选用 LSTM 意味着有更多参数，需要被训练。</p>
<p>训练数据通常不包含读写操作发生在哪个存储空间上的信息。譬如 NTM 中，Priority Sort实验的训练数据，是一连串（输入，理想输出）pairs。每个 pair 中的输入，是 20 个向量，每个向量伴随着 priority 打分。每个 pair 中的理想输出，是从输入的 20 个向量中，挑选出来的 16 个，并且按 priority 得分排序。</p>
<p>注意，训练数据中不包含读写操作在哪些存储单元上进行的信息。</p>
<p>把 DNC 应用到 Graph 操作中</p>
<p>文中把 DNC 用于在伦敦地铁中，寻找两站之间最佳路线。坐地铁本身不重要，重要的是如果 RNN 学会使用 Graph 以后，能做什么？假如 Graph 不是地铁，而是 social graph 呢？又假如是 knowledge graph 呢？</p>
<p>文章转自新智元公众号，<a href="https://mp.weixin.qq.com/s/0swSalPLfX0JWjfEsje-yw" rel="external nofollow noreferrer">原文链接</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-05 06:16:10</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%ad%98%e5%82%a8/" title="存储">存储</a>, <a href="https://www.iamivan.net/tag/%e6%b7%b1%e5%ba%a6%e5%ad%a6%e4%b9%a0/" title="深度学习">深度学习</a>, <a href="https://www.iamivan.net/tag/network/" title="network">network</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>深度学习挑战冯·诺依曼结构的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/My33Pvz.html" rel="bookmark">脑芯编：分手？摆脱冯诺依曼的深度学习硬件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不知不觉,&lt;脑芯编&gt;已经走过了上半阙.默默挥手告别那些弃剧的看官,也由衷感谢仍然愿意用手指点进来的您.你们是撑住脑芯编不烂尾的重要力量,与其肉麻,不如再念一遍诗的上半阙: 昨夜神风送层云,(神经元与网络) 几重卷积几重生.(卷积神经网络) 梦里不知形与令,(计算体系结构) 烛台簇华照单影.(单指令多数据) 上次我们讲到,现行的计算机体系结构--&quot;冯诺依曼&quot;结构是阻碍深度学习神经网络的一个重要瓶颈.其计算和存储分离的特点,使得神经元计算的效率低下.合理改变指令集,加入乘累加指			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZBBD4z.html" rel="bookmark">人工智能在深度学习领域的前世今生</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				雷锋网(公众号:雷锋网)按:本文作者兰彻, 文章详细介绍了1)人工智能发展的七个重要阶段:2)深度学习在人工智能的发展:3)最后也提出作者对于深度学习挑战和未来发展的看法. 这两年人工智能热闹非凡,不仅科技巨头发力AI取得技术与产品的突破,还有众多初创企业获得风险资本的青睐,几乎每周都可以看到相关领域初创公司获得投资的报道,而最近的一次春雷毫无疑问是Google旗下Deepmind开发的人工智能AlphaGo与南韩李世石的围棋之战,AiphaGo大比分的获胜让人们对AI刮目相看的同时也引发了对A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MrqXgmb.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;迎接深度学习的&OpenCurlyDoubleQuote;大&rdquo;挑战&lpar;下&rpar;  1&period;1 深度学习的训练方法和技巧</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要:本部分主要介绍了深度学习的训练方法和技巧.深度学习的挑战和应对方法等问题. 最后结合眼下 AI 的研究进展,对深度学习领域深刻的&quot;吐槽&quot;了一番,妙趣横生且发人深省. 1.1 深度学习的训练方法和技巧 前面提到的 BN 方法还不能解决所有的 问题. 因为即便做了白化,激活函数的导 数的最大值也只有 0.25,如果层数成百上 千,0.25 不断连乘以后,将很快衰减为 0. 所以后来又涌现出一些更加直接.更加有 效的方法.其基本思路是在各层之间建立 更畅通的渠道,让信息流绕过非线性的激			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zJejdJp.html" rel="bookmark">预告：深度学习新星：GANs的诞生与走向（主讲人冯佳时 ）丨硬创公开课</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在大数据和人工智能界,常有这么个说法&quot;谁掌握了数据,谁就占据AI高地.&quot; 但是&quot;掌握数据&quot;往往意味着巨大成本.首先海量数据经常被大型企业垄断,给原始数据标记也需要耗费巨大资金. 所以,基于数据而习得&quot;特征&quot;的深度学习技术受到狂热追捧,而其中GANs模型训练方法更加具有激进意味:它生成数据本身. GANs是&quot;生成对抗网络&quot;(Generative Adversarial Networks)的简称,由2014年还在蒙特利尔读博士的I			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bKy575p.html" rel="bookmark">从传统 CAD 到深度学习驱动的影像系统：智能医疗落地三大技术挑战</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				图像识别是深度学习等 AI 技术最先突破的领域,而在 AI 与医疗场景的结合中,目前看来,基于深度学习技术的医疗影像的识别与分析,也很可能会在整个智能医疗.精准医疗领域一枝独秀,率先进入大规模应用阶段.   传统 CAD 不受医生的欢迎 实际上,计算机辅助检测(computeraided detection,简称CAD)很早就进入了人们尤其是医疗工作者的视线.有意思的是,很早以前就已经尝试使用过CAD系统的放射科专家们,在这一波智能医疗影像新技术的推广中并不热心,因为在他们的印象中,过去的CAD			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b2JWXob.html" rel="bookmark">中国人工智能学会通讯&mdash;&mdash;后深度学习时代的人工智能</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1956 年,在美国达特茅斯学院举行的一次会议上,&quot;人工智能&quot;的研究领域正式确立.60 年后的今天,人工智能的发展正进入前所未有的大好时期.我今天作的报告,将通过分析时代的特点,这个时代下人工智能与计算机的可能命运,来重新认识人工智能.认识我们赖以生存的计算机,还有我们自己. 后深度学习时代的前提 我们看到如今人工智能的春天又来了,不过和 30 年前日本兴起的人工智能热潮相比,发生了如下变化:时间不同.地点不同.主题也不同.这次人工智能的大发展与深度学习紧密相关,体现在:① 从知识情报			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bjQGm6z.html" rel="bookmark">【深度学习框架大PK】褚晓文教授：五大深度学习框架三类神经网络全面测评（23PPT）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				香港浸会大学褚晓文教授团队在2016年推出深度学习工具评测的研究报告,并在2017年年初发布更新,引起广泛关注.见新智元报道&lt; 基准评测 TensorFlow.Caffe.CNTK.MXNet.Torch 在三类流行深度神经网络上的表现(论文)&gt;,2017年初版本的评测的主要发现可概括如下: 总体上,多核CPU的性能并无很好的可扩展性.在很多实验结果中,使用16核CPU的性能仅比使用4核或8核稍好.TensorFlow在CPU环境有相对较好的可扩展性. 仅用一块GPU卡的话,FCN上Caffe			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zZ7eXwb.html" rel="bookmark">谢源：计算存储一体化，在存储里做深度学习，架构创新实现下一代AI芯片</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				谢源教授于1997年获得清华大学电子工程系学士学位,于1999年和2002年获得普林斯顿大学电机工程系硕士和博士学位.于2003年加入宾夕法尼亚州立大学计算机系,2008年获得终身教职,2012年提升正教授.2014年他转入加州大学圣芭芭拉分校电机与计算机工程系(ECE)担任正教授.他同时也是北京大学的兼职教授和台湾新竹清华大学的客座教授. 谢源教授也拥有丰富的工业界经验,他于2002-2003年任职于IBM担任微电子部门全球设计中心的咨询工程师,2012年到2013年期间加入AMD,负责组建和			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Lp5AYAp.html" rel="bookmark">专访 &vert; 清华大学朱军：深度学习&OpenCurlyDoubleQuote;盛行&rdquo;，传统方法何去何从？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				朱军博士是清华大学计算机系长聘副教授.智能技术与系统国家重点实验室副主任.卡内基梅隆大学兼职教授.2013年,入选IEEE Intelligent Systems的&quot;人工智能10大新星&quot;(AI's 10 to Watch).他主要从事机器学习研究,在国际重要期刊与会议发表学术论文80余篇.担任国际期刊IEEE TPAMI和Artificial Intelligence的编委.国际会议ICML 2014地区联合主席.以及ICML.NIPS等国际会议的领域主席. 清华大学计算机系长聘副教授			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/vMNx4zk.html" rel="bookmark" class="title">Android ApiDemos示例解析&lpar;33&rpar;：App-&amp;amp&semi;gt&semi;Preferences-&amp;amp&semi;gt&semi;Default Values</a>
					<div>
						DefaultValues 介绍了如何在XML中定义Preference的缺省值. &lt;CheckBoxPreference android:key=&quot; default_toggle&q ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Lp5Nemz.html" rel="bookmark" class="title">近距无线通信技术综述</a>
					<div>
						目前使用较广泛的近距无线通信技术是蓝牙(Bluetooth),无线局 域网802.11(Wi-Fi)和红外数据传输(IrDA).同时还有一些具有发展潜力的近距无线技术标准,它们分别是:ZigBee.超 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOmWkM.html" rel="bookmark" class="title">值类型与引用类型（中&rpar;</a>
					<div>
						本文将介绍以下内容: 类型的基本概念  值类型深入 引用类型深入 值类型与引用类型的比较及应用    1. 引言 上回[第八回:品味类型---值类型与引用类型(上)-内存有理]的发布,受到大家的不少关 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LpdD4Xp.html" rel="bookmark" class="title">一个月到底可以把流量做到多大&quest;</a>
					<div>
						流量 昨天写了一个文章,我们被百度逼着作弊,我的文采不好,内容上可能不成逻辑,所以被站上的朋友骂了一通,在这里向各位道歉,今天总结自己做站一来的网站推广经验,希望和大家一块来研究网站推广      0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/LzJgmvb.html" rel="bookmark" class="title">关于JSP发布地图服务</a>
					<div>
						js &lt;b&gt;关于JSP发布地图服务&lt;/b&gt;首先介绍下用于发布地图服务的ArsIMSArsIMS是一个由Presentation层,Business Logic层,data层组成 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA9LvM.html" rel="bookmark" class="title">京东咚咚简介</a>
					<div>
						京东咚咚是京东商城发布的一款类似于阿里旺旺的个人IM软件,名为&quot;京东咚咚&quot;.从官网(dongdong.jd.com)介绍来看,京东咚咚主要有两部分功能,一是个人用户之间的沟通,可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrO28p.html" rel="bookmark" class="title">Oracle基于备份控制文件的恢复</a>
					<div>
						通常在当前控制文件丢失,或者当前的控制文件与需要恢复的控制文件不一致的情况下,我们需要重新创建一个控制文件或者使用 unsingbackup controlfile方式来恢复控制文件.说简单点,只要是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRr9nz.html" rel="bookmark" class="title">win7系统开机黑屏只有鼠标怎么办？</a>
					<div>
						        win7系统开机黑屏只有鼠标怎么办?   如果自己对电脑不懂的话,最简单的方法就是强制关机,这个关机以后,在开机,就没有问题了. 或者开机以后,我们按一下电源键,这时候屏幕会黑了,电脑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZw34z.html" rel="bookmark" class="title">如何简单四步卸载Win7 SP1系统</a>
					<div>
						  第一步:在开始菜单中的搜索框中输入&quot;Windows Update&quot;,打开Windows自动更新窗口. 第二步:在自动更新窗口中点击左侧的安装升级选项. 第三步:从这里你应该可以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjmd5Vz.html" rel="bookmark" class="title">Photoshop怎样使文字边缘填充颜色或渐变色</a>
					<div>
						  文字边缘填充颜色,可描边功能.如要给文字边缘使用渐变色,先新建一个透明层,然后选中文字,然后在图层中选中透明层,实行描边功能,然后把描边的层变成选区,填上渐变色即可. 分类: PS入门教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQN99oM.html" rel="bookmark" class="title">win8怎么设置开机自动开启数字小键盘</a>
					<div>
						  win8设置开机自动开启数字小键盘方法: 按win+R键,输入regedit,依次找到HKEY_USERS - DEFAULT - ControlPanel - Keyboard 将它右边的Ini ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJVDlp.html" rel="bookmark" class="title">化解无线网络的安全威胁 享受便利快捷</a>
					<div>
						伴随着低档次无线网络设备的价格不断走低,以及操作上的越来越简便,低档次无线局域网网络在最近几年得到了快速普及.为了方便进行资源共享.无线打印. 移动办公操作,我们只要耗费几百元钱购买一台普通的无线路由 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MArKZAp.html" rel="bookmark" class="title">HP-EVA4400故障导致的oracle数据库丢失的恢复过程</a>
					<div>
						一.故障描述 整个EVA存储结构是由一台EVA4400控制器,三台EVA4400扩展柜和28块FC 300G硬盘构成的.由于两块磁盘掉线导致存储某些LUN不可用,某些LUN丢失.由于EVA4400是因 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOaNg8M.html" rel="bookmark" class="title">mysql 5&period;7版本安装问题</a>
					<div>
						2013年10月,MySQL开发团队正式宣布支持Yum仓库,这就意味着我们现在可以从这个Yum库中获得最新和最优版的MySQL安装包.本文将在一台全新安装的CentOS6上安装MySQL5.6,如果你 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze7JeVM.html" rel="bookmark" class="title">左右脑年龄测试火爆朋友圈：程序员辟谣</a>
					<div>
						最近,左右脑测试在朋友圈非常火爆,你只需要进入相应入口并回答几个设定的问题后,就会出现你左右脑两个年龄测试结果,到底这个测试靠谱吗? 对于测试结果的真实性,有程序员出面表示,其在认真研究这个测试的代码 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDW9yLp.html" rel="bookmark" class="title">MFC用VS编时钟的时候怎么把系统时间同步在钟表指针上？</a>
					<div>
						问题描述 MFC用VS编时钟的时候怎么把系统时间同步在钟表指针上? CTime GetCurrentTime获得了系统时间,我能直接显示成字符串,但是怎么变成指针呢???比如字符串显示12:30:40 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPPV6qp.html" rel="bookmark" class="title">mysql-MySQL：多字段复合统计</a>
					<div>
						问题描述 MySQL:多字段复合统计 菜鸟求助:eves表中有三个国家字段,nat1 nat2 nat3,nat1为非空,其它两个不一定有数据.现在想统计3列中每个国家(包括出现在nat2和nat3里 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdEqxAz.html" rel="bookmark" class="title">2个jsp，内容一样，所在位置也一样，通过一个访问另一个，为什么会出现不同的样式</a>
					<div>
						问题描述 2个jsp,内容一样,所在位置也一样,通过一个访问另一个,为什么会出现不同的样式 通过mvc发布的一个响应,webroot下有个文件夹,2个jsp文件,内容完全一样,但是名称不一样,一个叫a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MRqQOBb.html" rel="bookmark" class="title">网络-怎么在windows8&period;1系统下把c&colon;users洋目录下的洋改名为英文yang</a>
					<div>
						问题描述 怎么在windows8.1系统下把c:users洋目录下的洋改名为英文yang 怎么在windows8.1系统下把c:users洋目录下的洋改名为英文yang ? 请大神指导,谢谢. 解决方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MgRKK6b.html" rel="bookmark" class="title">如何在Web&period;config中注册用户控件和自定义控件</a>
					<div>
						问题: 在ASP.NET 的早先版本里,开发人员通过在页面的顶部添加 指令来引入和使用自定义服务器控件和用户控件时,象这样:   &lt;%@ Register TagPrefix=&quot;sco ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3r2Vwz.html" rel="bookmark" class="title">apache&plus;3tomcat&plus;jk&plus;memcached集群环境搭建</a>
					<div>
						注意本文不讨论原理,只讲述具体的搭建过程,而且步骤都经过了整理,否则过程可能会出现其他异常,请自行google.apache与tomcat整合的方式除了jk之外,使用apache自带的mod_ajp_ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bE4YB3z.html" rel="bookmark" class="title">32bit-JNative的问题&comma;提示32位DLL不能再64位平台上运行</a>
					<div>
						问题描述 JNative的问题,提示32位DLL不能再64位平台上运行 我使用JNative调用的C++自己写的DLL动态库文件,我在测试项目中运行的毫无问题 ,使用语句输出位数信息是32位 Prop ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ba74YQp.html" rel="bookmark" class="title">如何Regex&period;Match截取一段字符串</a>
					<div>
						问题描述 假如我要截取&quot;aaa1dfdgg2fffd&quot;中的1和2之间的字符串,用regex这个函数要怎么写代码我写的代码把1和2也包括在内了 解决方案 解决方案二:Regex.Ma ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b3JQqgz.html" rel="bookmark" class="title">网购可申请分期付款</a>
					<div>
						商报讯(记者 洪叶)随着近两年银行的大力推广,信用卡分期付款对众多持卡者来说,已不再陌生.如今,&quot;信用卡分期&quot;这种付款已经从线下推广至线上.7月底,支付宝宣布,目前招行.中行.农行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze027jp.html" rel="bookmark" class="title">分治法&mdash;&mdash;循环赛日程安排问题</a>
					<div>
						问题描述: 设有n(2^k)位选手参加网球循环赛,循环赛共进行n-1天,每位选手要与其他n-1位选手比赛一场,且每位选手每天只能赛一场,试安排比赛.   举例说明: 1,当n为偶数时,循环赛一共要进行 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pL5WPkz.html" rel="bookmark" class="title">灌篮高手高星卡牌如何抽取 神秘商店抽取高星卡牌攻略</a>
					<div>
						灌篮高手手游神秘商店抽取高星卡牌攻略: 1.神秘商店每隔2个小时自动刷新商品列表 2.商店中经常出售一些高星级卡牌.卡牌碎片还有装备等 3.需要支付钻石或者SD点数才能购买 4.SD点数可以通过分解5 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdmZLNz.html" rel="bookmark" class="title">航天机电抢食新材料产业&OpenCurlyDoubleQuote;大蛋糕&rdquo;</a>
					<div>
						日前,上海航天汽车机电股份有限公司向中国北车集团交付了首套CRH3-380列车前锥产品.该产品的顺利交付标志着航天机电成功研制出国内首台国产化高速列车前锥,极大拓宽了该公司新材料应用的范围,并形成了该 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8N1axb.html" rel="bookmark" class="title">svn merge和branch</a>
					<div>
						使用svn几年了,一直对分支和合并敬而远之,一来是因为分支的管理不该我操心,二来即使涉及到分支的管理,也不敢贸然使用合并功能,生怕合并出了问题对团队造成不良影响,最主要的原因是,自己对分支的目的和合并 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/baq7LQb.html" rel="bookmark" class="title">J2ME中有没有方法读取SIM卡中的内容&quest;</a>
					<div>
						 其实国外也在讨论这个问题,呵呵.  一般性的答案是:可以的.只不过现在的手机尚且不支持此标准. 更多的信息: 对于JavaCard这种东西,MIDP2.0中扩展了一个叫做Security and T ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNmPEyb.html" rel="bookmark" class="title">顺丰和圆通两公司表示高度重视此事，并对报道的问题实施整改</a>
					<div>
						央视&lt;第一时间&gt;曝光快递乱象,顺丰[微博]速运.韵达快递.圆通[微博]速递暴力分拣,私自拆看客户包裹,漠视收件人投诉.15日,圆通速递和顺丰速递先后在官方微博发布声明进行回应,两公司表示高 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.033 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
